VERSION 5.00
Object = "{54850C51-14EA-4470-A5E4-8C5DB32DC853}#1.0#0"; "vsprint8.ocx"
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.ocx"
Begin VB.Form Form1 
   Caption         =   "VSPrint: Preserving RTF Line Breaks"
   ClientHeight    =   7830
   ClientLeft      =   2130
   ClientTop       =   1260
   ClientWidth     =   5595
   LinkTopic       =   "Form1"
   ScaleHeight     =   7830
   ScaleWidth      =   5595
   Begin VB.CommandButton Command2 
      Caption         =   "?"
      Height          =   420
      Left            =   3285
      TabIndex        =   3
      Top             =   45
      Width           =   465
   End
   Begin VB.CommandButton Command1 
      Caption         =   "&Render RTF preserving line breaks"
      Height          =   420
      Left            =   45
      TabIndex        =   2
      Top             =   45
      Width           =   3150
   End
   Begin RichTextLib.RichTextBox RichTextBox1 
      Height          =   1545
      Left            =   45
      TabIndex        =   1
      Top             =   540
      Width           =   5175
      _ExtentX        =   9128
      _ExtentY        =   2725
      _Version        =   393217
      TextRTF         =   $"Form1.frx":0000
   End
   Begin VSPrinter8LibCtl.VSPrinter VSPrinter1 
      Height          =   5475
      Left            =   90
      TabIndex        =   0
      Top             =   2115
      Width           =   5325
      _cx             =   9393
      _cy             =   9657
      Appearance      =   1
      BorderStyle     =   1
      Enabled         =   -1  'True
      MousePointer    =   0
      BackColor       =   -2147483643
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Arial"
         Size            =   11.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      BeginProperty HdrFont {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      AutoRTF         =   -1  'True
      Preview         =   -1  'True
      DefaultDevice   =   0   'False
      PhysicalPage    =   -1  'True
      AbortWindow     =   -1  'True
      AbortWindowPos  =   0
      AbortCaption    =   "Printing..."
      AbortTextButton =   "Cancel"
      AbortTextDevice =   "on the %s on %s"
      AbortTextPage   =   "Now printing Page %d of"
      FileName        =   ""
      MarginLeft      =   1440
      MarginTop       =   1440
      MarginRight     =   1440
      MarginBottom    =   1440
      MarginHeader    =   0
      MarginFooter    =   0
      IndentLeft      =   0
      IndentRight     =   0
      IndentFirst     =   0
      IndentTab       =   720
      SpaceBefore     =   0
      SpaceAfter      =   0
      LineSpacing     =   100
      Columns         =   1
      ColumnSpacing   =   180
      ShowGuides      =   2
      LargeChangeHorz =   300
      LargeChangeVert =   300
      SmallChangeHorz =   30
      SmallChangeVert =   30
      Track           =   0   'False
      ProportionalBars=   -1  'True
      Zoom            =   29.4507575757576
      ZoomMode        =   3
      ZoomMax         =   400
      ZoomMin         =   10
      ZoomStep        =   5
      EmptyColor      =   -2147483636
      TextColor       =   0
      HdrColor        =   0
      BrushColor      =   0
      BrushStyle      =   0
      PenColor        =   0
      PenStyle        =   0
      PenWidth        =   0
      PageBorder      =   0
      Header          =   ""
      Footer          =   ""
      TableSep        =   "|;"
      TableBorder     =   7
      TablePen        =   0
      TablePenLR      =   0
      TablePenTB      =   0
      NavBar          =   4
      NavBarColor     =   -2147483633
      ExportFormat    =   0
      URL             =   ""
      Navigation      =   3
      NavBarMenuText  =   "Whole &Page|Page &Width|&Two Pages|Thumb&nail"
      AutoLinkNavigate=   0   'False
      AccessibleName  =   ""
      AccessibleDescription=   ""
      AccessibleValue =   ""
      AccessibleRole  =   9
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, wParam As Any, lParam As Any) As Long
Private Type POINTAPI
    x As Long
    y As Long
End Type
Private Const EM_POSFROMCHAR = &HD6&

Private Function GetRTFWidth(rtfCtl As Object) As Long
    With rtfCtl
        Dim pt As POINTAPI
        SendMessage .hwnd, EM_POSFROMCHAR, pt, 0
        GetRTFWidth = pt.x * Screen.TwipsPerPixelX
    End With
End Function

Private Sub Command1_Click()

    With VSPrinter1
    
        .BrushStyle = bsTransparent
        .PenStyle = psDot
        .PenColor = RGB(150, 150, 150)
        
        .StartDoc

        ' calculate textbox dimensions
        ' add a little extra space to the box width to prevent spurious wrapping
        Dim w, h
        w = RichTextBox1.Width + 100
        h = RichTextBox1.Height
        
        ' replace soft line breaks with hard breaks (vbLf)
        SetLineBreaks RichTextBox1, True
        
        ' render the rich text box
        .TextBox RichTextBox1.TextRTF, .MarginLeft, .MarginTop, w, h, True, False, True
        
        ' measure the horizontal extent of the RTF text
        .BrushStyle = bsTransparent
        .PenStyle = psSolid
        w = GetRTFWidth(RichTextBox1)
        .DrawRectangle .MarginLeft, .MarginTop, .MarginLeft + w, .MarginTop + h
        
        ' restore control text
        SetLineBreaks RichTextBox1, False
        
        .EndDoc
    End With

End Sub

Sub SetLineBreaks(rtf As RichTextBox, bSet As Boolean)
    Static sSaveTextRTF$, sText$
    
    ' to reset, restore previously saved value
    If Not bSet Then
        rtf.TextRTF = sSaveTextRTF
        Exit Sub
    End If
    
    ' before setting, save current contents to restore later
    sSaveTextRTF = rtf.TextRTF
    
    ' replace soft line breaks (at spaces) with hard breaks (vbLf)
    Dim i&, iLine&, iPrev&, iLen&
    sText = rtf.Text
    iLen = Len(sText)
    For i = 0 To iLen
        iLine = rtf.GetLineFromChar(i)
        If iLine <> iPrev Then
            If Mid(sText, i, 1) = " " Then
                sText = Left(sText, i - 1) & vbLf & Mid(sText, i + 1)
            End If
        End If
        iPrev = iLine
    Next
    rtf.Text = sText
    
End Sub

Private Sub Form_Load()
    With RichTextBox1
        .Font.Name = "Tahoma"
        .Font.Size = 12
        .Text = "Type any text and click the button to render it preserving the line breaks."
    End With
End Sub

Private Sub Form_Resize()
    On Error Resume Next
    With RichTextBox1
        .Move .Left, .Top, ScaleWidth - 2 * .Left
        VSPrinter1.Move .Left, .Top + .Height + .Left, .Width, ScaleHeight - VSPrinter1.Top - .Left
    End With
End Sub

Private Sub Command2_Click()
    Dim s$
    On Error Resume Next
    Open App.Path & "\readme.txt" For Binary As #1
    s = Input(LOF(1), 1)
    Close #1
    If Err > 0 Then s = "Sorry, can't find Readme.txt."
    MsgBox s, vbInformation, "Readme.txt"
    On Error GoTo 0
End Sub


